glibmm 2.4: Gio::DataInputStream Class Reference

Main Page Widgets glibmm Namespaces Book

# Gio::DataInputStream Class Reference
[Stream Classes]

An implementation of BufferedInputStream that allows for high-level data manipulation of arbitrary data (including binary operations). More...

Inheritance diagram for Gio::DataInputStream:

[legend]

List of all members.

## Public Member Functions
virtual | ~DataInputStream ()
GDataInputStream* | gobj ()
| Provides access to the underlying C GObject.
const GDataInputStream* | gobj () const
| Provides access to the underlying C GObject.
GDataInputStream* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
void | set_byte_order (DataStreamByteOrder order)
| This function sets the byte order for the given stream.
DataStreamByteOrder | get_byte_order () const
| Gets the byte order for the data input stream.
void | set_newline_type (DataStreamNewlineType type)
| Sets the newline type for the stream.
DataStreamNewlineType | get_newline_type () const
| Gets the current newline type for the stream.
guchar | read_byte (const Glib::RefPtr<Cancellable>& cancellable)
| Reads an unsigned 8-bit/1-byte value from stream.
guchar | read_byte ()
| non-cancellable version of read_byte()
gint16 | read_int16 (const Glib::RefPtr<Cancellable>& cancellable)
| Reads a 16-bit/2-byte value from stream.
gint16 | read_int16 ()
| non-cancellable version of read_int16()
guint16 | read_uint16 (const Glib::RefPtr<Cancellable>& cancellable)
| Reads an unsigned 16-bit/2-byte value from stream.
guint16 | read_uint16 ()
| non-cancellable version of read_uint16()
gint32 | read_int32 (const Glib::RefPtr<Cancellable>& cancellable)
| Reads a signed 32-bit/4-byte value from stream.
gint32 | read_int32 ()
| non-cancellable version of read_int32()
guint32 | read_uint32 (const Glib::RefPtr<Cancellable>& cancellable)
| Reads an unsigned 32-bit/4-byte value from stream.
guint32 | read_uint32 ()
| non-cancellable version of read_uint32()
gint64 | read_int64 (const Glib::RefPtr<Cancellable>& cancellable)
| Reads a 64-bit/8-byte value from stream.
gint64 | read_int64 ()
| non-cancellable version of read_int64()
guint64 | read_uint64 (const Glib::RefPtr<Cancellable>& cancellable)
| Reads an unsigned 64-bit/8-byte value from stream.
guint64 | read_uint64 ()
| non-cancellable version of read_uint64()
bool | read_line (std::string& line, const Glib::RefPtr<Cancellable>& cancellable)
bool | read_line (std::string& line)
| non-cancellable version of read_line()
bool | read_until (std::string& data, const std::string& stop_chars, const Glib::RefPtr<Cancellable>& cancellable)
bool | read_until (std::string& data, const std::string& stop_chars)
| non-cancellable version of read_until()
## Static Public Member Functions
static Glib::RefPtr <DataInputStream> | create (const Glib::RefPtr<InputStream>& base_stream)
## Protected Member Functions
| DataInputStream (const Glib::RefPtr<InputStream>& base_stream)
## Related Functions
(Note that these are not member functions.)
Glib::RefPtr <Gio::DataInputStream> | wrap (GDataInputStream* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

An implementation of BufferedInputStream that allows for high-level data manipulation of arbitrary data (including binary operations).

Since glibmm 2.16:

## Constructor & Destructor Documentation

virtual Gio::DataInputStream::~DataInputStream | ( |  | ) | `[virtual]`

Gio::DataInputStream::DataInputStream | ( | const Glib::RefPtr<InputStream>& | base_stream | ) | `[explicit, protected]`

## Member Function Documentation

GDataInputStream* Gio::DataInputStream::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C GObject.

Reimplemented from Gio::BufferedInputStream.

const GDataInputStream* Gio::DataInputStream::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C GObject.

Reimplemented from Gio::BufferedInputStream.

GDataInputStream* Gio::DataInputStream::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

Reimplemented from Gio::BufferedInputStream.

static Glib::RefPtr<DataInputStream> Gio::DataInputStream::create | ( | const Glib::RefPtr<InputStream>& | base_stream | ) | `[static]`

Reimplemented from Gio::BufferedInputStream.

void Gio::DataInputStream::set_byte_order | ( | DataStreamByteOrder | order | ) |

This function sets the byte order for the given stream.

All subsequent reads from the stream will be read in the given order.

Parameters:

  | order | A DataStreamByteOrder to set.

DataStreamByteOrder Gio::DataInputStream::get_byte_order | ( |  | ) | const

Gets the byte order for the data input stream.

Returns:
  The stream's current DataStreamByteOrder.

void Gio::DataInputStream::set_newline_type | ( | DataStreamNewlineType | type | ) |

Sets the newline type for the stream.

Note that using G_DATA_STREAM_NEWLINE_TYPE_ANY is slightly unsafe. If a read chunk ends in "CR" we must read an additional byte to know if this is "CR" or "CR LF", and this might block if there is no more data availible.

Parameters:

  | type | The type of new line return as DataStreamNewlineType.

DataStreamNewlineType Gio::DataInputStream::get_newline_type | ( |  | ) | const

Gets the current newline type for the stream.

Returns:
  DataStreamNewlineType for the given stream.

guchar Gio::DataInputStream::read_byte | ( | const Glib::RefPtr<Cancellable>& | cancellable | ) |

Reads an unsigned 8-bit/1-byte value from stream.

Parameters:

  | cancellable | Optional Cancellable object, `0` to ignore.

Returns:
  An unsigned 8-bit/1-byte value read from the stream or 0 if an error occurred.

Reimplemented from Gio::BufferedInputStream.

guchar Gio::DataInputStream::read_byte | ( |  | ) |

non-cancellable version of read_byte()

Reimplemented from Gio::BufferedInputStream.

gint16 Gio::DataInputStream::read_int16 | ( | const Glib::RefPtr<Cancellable>& | cancellable | ) |

Reads a 16-bit/2-byte value from stream.

In order to get the correct byte order for this read operation, see Glib::data_stream_get_byte_order() and Glib::data_stream_set_byte_order().

Parameters:

  | cancellable | Optional Cancellable object, `0` to ignore.

Returns:
  A signed 16-bit/2-byte value read from stream or 0 if an error occurred.

gint16 Gio::DataInputStream::read_int16 | ( |  | ) |

non-cancellable version of read_int16()

guint16 Gio::DataInputStream::read_uint16 | ( | const Glib::RefPtr<Cancellable>& | cancellable | ) |

Reads an unsigned 16-bit/2-byte value from stream.

In order to get the correct byte order for this read operation, see Glib::data_stream_get_byte_order() and Glib::data_stream_set_byte_order().

Parameters:

  | cancellable | Optional Cancellable object, `0` to ignore.

Returns:
  An unsigned 16-bit/2-byte value read from the stream or 0 if an error occurred.

guint16 Gio::DataInputStream::read_uint16 | ( |  | ) |

non-cancellable version of read_uint16()

gint32 Gio::DataInputStream::read_int32 | ( | const Glib::RefPtr<Cancellable>& | cancellable | ) |

Reads a signed 32-bit/4-byte value from stream.

In order to get the correct byte order for this read operation, see Glib::data_stream_get_byte_order() and Glib::data_stream_set_byte_order().

The operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, a Gio::Error will be thrown with CANCELLED.

Parameters:

  | cancellable | Cancellable object.

Returns:
  A signed 32-bit/4-byte value read from the stream or 0 if an error occurred.

gint32 Gio::DataInputStream::read_int32 | ( |  | ) |

non-cancellable version of read_int32()

guint32 Gio::DataInputStream::read_uint32 | ( | const Glib::RefPtr<Cancellable>& | cancellable | ) |

Reads an unsigned 32-bit/4-byte value from stream.

In order to get the correct byte order for this read operation, see Glib::data_stream_get_byte_order() and Glib::data_stream_set_byte_order().

The operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, a Gio::Error will be thrown with CANCELLED.

Parameters:

  | cancellable | Cancellable object.

Returns:
  An unsigned 32-bit/4-byte value read from the stream or 0 if an error occurred.

guint32 Gio::DataInputStream::read_uint32 | ( |  | ) |

non-cancellable version of read_uint32()

gint64 Gio::DataInputStream::read_int64 | ( | const Glib::RefPtr<Cancellable>& | cancellable | ) |

Reads a 64-bit/8-byte value from stream.

In order to get the correct byte order for this read operation, see Glib::data_stream_get_byte_order() and Glib::data_stream_set_byte_order().

The operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, a Gio::Error will be thrown with CANCELLED.

Parameters:

  | cancellable | Cancellable object.

Returns:
  A signed 64-bit/8-byte value read from stream or 0 if an error occurred.

gint64 Gio::DataInputStream::read_int64 | ( |  | ) |

non-cancellable version of read_int64()

guint64 Gio::DataInputStream::read_uint64 | ( | const Glib::RefPtr<Cancellable>& | cancellable | ) |

Reads an unsigned 64-bit/8-byte value from stream.

In order to get the correct byte order for this read operation, see Glib::data_stream_get_byte_order().

The operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, a Gio::Error will be thrown with CANCELLED.

Parameters:

  | cancellable | Cancellable object.

Returns:
  An unsigned 64-bit/8-byte read from stream or 0 if an error occurred.

guint64 Gio::DataInputStream::read_uint64 | ( |  | ) |

non-cancellable version of read_uint64()

bool Gio::DataInputStream::read_line | ( | std::string & | line,
|  | const Glib::RefPtr<Cancellable>& | cancellable |
| ) |  |  |

bool Gio::DataInputStream::read_line | ( | std::string & | line | ) |

non-cancellable version of read_line()

bool Gio::DataInputStream::read_until | ( | std::string & | data,
|  | const std::string & | stop_chars,
|  | const Glib::RefPtr<Cancellable>& | cancellable |
| ) |  |  |

bool Gio::DataInputStream::read_until | ( | std::string & | data,
|  | const std::string & | stop_chars |
| ) |  |  |

non-cancellable version of read_until()

## Friends And Related Function Documentation

Glib::RefPtr<Gio::DataInputStream> wrap | ( | GDataInputStream * | object,
|  | bool | take_copy = `false` |
| ) |  |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  | object | The C instance.
  | take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- datainputstream.h